import React, { useState, useEffect } from 'react'
import { Button, Descriptions, Input } from 'antd'
import styles from './BaseConfig.less'
import { S_GetDataBaseConfig, GetTCPConfigInfo, GetDataBaseConfig, GetBasicInfo } from '@/services/platform/hostmanager'




const BaseConfig = () => {


    const [currentDataBase, setCurrentDataBase] = useState({userName:"",password:"",dbName:"",ip:""});
    const [currentSiteInfo, setcurrentSiteInfo] = useState("");


    useEffect(() => {
        getCurrentConfig()
        getSiteCode()
    }, [])

    const getCurrentConfig = () => {

        GetDataBaseConfig().then(
            res => {
                if (res.code === 0) {
                    setCurrentDataBase(res.data)
                }
            }
        )
    }
    const getSiteCode = () => {
        GetBasicInfo().then(
            res => {
                if (res.code === 0) {
                    setcurrentSiteInfo(res.data)
                }
            }
        )
    }
    // return (
    //     <div className={styles.base_container}>
    //         <Card title="数据库连接" style={{ width: 300 }}>
    //             <Card type="inner" title="服务器IP" style={{ margin: 10 }}>
    //                 {currentDataBase.ip}
    //             </Card>
    //             <Card type="inner" title="数据库名称" style={{ margin: 10 }}>
    //                 {currentDataBase.dbName}
    //             </Card>

    //         </Card>
    //         <Card title="权限验证" style={{ width: 300, marginLeft: 15 }}>
    //             <Card type="inner" title="登录名" style={{ margin: 10 }}>
    //                 {currentDataBase.userName}
    //             </Card>
    //             <Card type="inner" title="密码" style={{ margin: 10 }}>
    //                 {currentDataBase.password}
    //             </Card>
    //         </Card>
    //         <Card title="站点信息" style={{ width: 300, marginLeft: 15 }}>
    //             <Card type="inner" title="站点编号" style={{ margin: 10 }}>
    //                 {currentSiteInfo}
    //             </Card>
    //         </Card>
    //     </div>
    // )
    const encrypt = (word) => {
        let encryptStr = ""
        for(let i = 0;i < word.length;i++){
            encryptStr += "*"
        }
        return encryptStr
    }
    return (
        <div className={styles.base_container}>
            <div style={{ backgroundColor: "white", padding: "10px", width: "100%" }}>
                <Descriptions title="" bordered >
                    <Descriptions.Item label="站点编号" span={3}>
                        {
                            currentSiteInfo?<Input value={currentSiteInfo} disabled={true} style={{with:"200px"}}/>:<div>
                                <Input value={currentSiteInfo} style={{width:"200px"}} />
                               <Button style={{marginLeft:"10px"}}>生成编号</Button>
                            </div>
                        }
                    </Descriptions.Item>
                    <Descriptions.Item label="服务器IP" span={3}>{currentDataBase.ip}</Descriptions.Item>
                    <Descriptions.Item label="数据库名称" span={3}>{currentDataBase.dbName}</Descriptions.Item>
                    <Descriptions.Item label="登录名" span={1}>{currentDataBase.userName}</Descriptions.Item>
                    <Descriptions.Item label="密码" span={1}>{encrypt(currentDataBase.password)}</Descriptions.Item>

                </Descriptions>
            </div>
        </div>
    )

}
export default BaseConfig

