/*
 * @Description: 
 * @Author: leizhe
 * @Date: 2021-08-03 11:38:03
 * @LastEditTime: 2021-08-04 10:29:01
 * @LastEditors: leizhe
 */
import React, { useState, useEffect } from 'react';
import styles from './index.less';
import { Row, Col, Select, Spin, Table, Input, Button } from 'antd';
import { SyncOutlined, PlusOutlined, ArrowUpOutlined } from '@ant-design/icons';

const videoManager = () => {
    const [configurationType, setConfigurationType] = useState('1')
    const [loading, setLoading] = useState(false); // 加载
    const [data, setData] = useState([]); // 源数据
    const [searchWord, setSearchWord] = useState(''); // 关键字
    const { Search } = Input;

    const columns = [
        {

        }, {

        }
    ]

    const selectChange = value => {
        setConfigurationType(value)
    }

    // 获取搜索框的值
    const handleSearch = e => {
        setSearchWord(e.target.value);
    };
    //搜索
    const submitSearchUser = () => {

    }
    //重置
    const handleReset = () =>{

    }

    //升级
    const upgrade = () =>{

    }
    //新增
    const addVideo = () =>{

    }
        return (
        <div className={styles.videoManagerContainer}>
            <Row className={styles.head}>
                <Col span={24}>
                    <span>配置类型：</span>
                    <Select
                        defaultValue="莹石云"
                        value={configurationType}
                        onChange={selectChange}
                        className={styles.sel}
                    >
                        <Option value="1">莹石云</Option>
                        <Option value="2">海康</Option>
                        <Option value="3">海康1.2</Option>
                        <Option value="4">海康NVR</Option>
                        <Option value="5">大华</Option>
                    </Select>
                    <span style={{ marginLeft: '50px' }}>快速搜索：</span>
                    <Search
                        style={{ width: 260 }}
                        placeholder="请输入名称，登录名，设备编码查询"
                        onSearch={submitSearchUser}
                        onChange={e => handleSearch(e)}
                        enterButton
                        value={searchWord}
                    />
                    <Button icon={<SyncOutlined className={styles.icon} />} onClick={handleReset} style={{ marginLeft: '30px', verticalAlign: 'middle', marginTop: '-3px' }}>
                        重置
                    </Button>
                    <Button icon={<ArrowUpOutlined className={styles.icon} />} onClick={upgrade} style={{ marginLeft: '30px', verticalAlign: 'middle', marginTop: '-3px' }}>
                        一键升级
                    </Button>
                    <Button icon={<PlusOutlined className={styles.icon} />} onClick={addVideo} style={{ marginLeft: '30px', verticalAlign: 'middle', marginTop: '-3px' }}>
                        新增
                    </Button>
                </Col>
            </Row>
            <Spin spinning={loading} tip="loading">
                <div className={styles.table}>
                    <Table
                        size="small"
                        bordered
                        columns={columns}
                        dataSource={data}
                        scroll={{ x: 'max-content', y: 'calc(100vh - 230px)' }}
                        pagination={{
                            showTotal: (total, range) =>
                                `第${range[0]}-${range[1]} 条/共 ${total} 条`,
                            pageSizeOptions: [10, 20, 50, 100],
                            defaultPageSize: 20,
                            showQuickJumper: true,
                            showSizeChanger: true,
                        }}
                    />
                </div>
            </Spin>
        </div>
    )
};

export default videoManager;